Linux Audio

Check our new training course

Loading...
v5.14.15
  1# SPDX-License-Identifier: GPL-2.0-only
  2# Makefile for the different targets used to generate full packages of a kernel
  3
  4include $(srctree)/scripts/Kbuild.include
 
  5
  6# RPM target
  7# ---------------------------------------------------------------------------
  8# The rpm target generates two rpm files:
  9# /usr/src/packages/SRPMS/kernel-2.6.7rc2-1.src.rpm
 10# /usr/src/packages/RPMS/i386/kernel-2.6.7rc2-1.<arch>.rpm
 11# The src.rpm files includes all source for the kernel being built
 12# The <arch>.rpm includes kernel configuration, modules etc.
 13#
 14# Process to create the rpm files
 15# a) clean the kernel
 16# b) Generate .spec file
 17# c) Build a tar ball, using symlink to make kernel version
 18#    first entry in the path
 19# d) and pack the result to a tar.gz file
 20# e) generate the rpm files, based on kernel.spec
 21# - Use /. to avoid tar packing just the symlink
 22
 23# Note that the rpm-pkg target cannot be used with KBUILD_OUTPUT,
 24# but the binrpm-pkg target can; for some reason O= gets ignored.
 25
 26# Remove hyphens since they have special meaning in RPM filenames
 27KERNELPATH := kernel-$(subst -,_,$(KERNELRELEASE))
 28KDEB_SOURCENAME ?= linux-upstream
 29KBUILD_PKG_ROOTCMD ?="fakeroot -u"
 30export KDEB_SOURCENAME
 31# Include only those top-level files that are needed by make, plus the GPL copy
 32TAR_CONTENT := $(KBUILD_ALLDIRS) .config .scmversion Makefile \
 33               Kbuild Kconfig COPYING $(wildcard localversion*)
 34MKSPEC     := $(srctree)/scripts/package/mkspec
 35
 36quiet_cmd_src_tar = TAR     $(2).tar.gz
 37      cmd_src_tar = \
 38if test "$(objtree)" != "$(srctree)"; then \
 39	echo >&2; \
 40	echo >&2 "  ERROR:"; \
 41	echo >&2 "  Building source tarball is not possible outside the"; \
 42	echo >&2 "  kernel source tree. Don't set KBUILD_OUTPUT, or use the"; \
 43	echo >&2 "  binrpm-pkg or bindeb-pkg target instead."; \
 44	echo >&2; \
 45	false; \
 46fi ; \
 47$(srctree)/scripts/setlocalversion --save-scmversion; \
 48tar -I $(KGZIP) -c $(RCS_TAR_IGNORE) -f $(2).tar.gz \
 49	--transform 's:^:$(2)/:S' $(TAR_CONTENT) $(3); \
 50rm -f $(objtree)/.scmversion
 51
 52# rpm-pkg
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 53# ---------------------------------------------------------------------------
 54PHONY += rpm-pkg
 55rpm-pkg:
 56	$(MAKE) clean
 57	$(CONFIG_SHELL) $(MKSPEC) >$(objtree)/kernel.spec
 58	$(call cmd,src_tar,$(KERNELPATH),kernel.spec)
 59	+rpmbuild $(RPMOPTS) --target $(UTS_MACHINE) -ta $(KERNELPATH).tar.gz \
 60	--define='_smp_mflags %{nil}'
 61
 62# binrpm-pkg
 63# ---------------------------------------------------------------------------
 64PHONY += binrpm-pkg
 65binrpm-pkg:
 66	$(MAKE) -f $(srctree)/Makefile
 67	$(CONFIG_SHELL) $(MKSPEC) prebuilt > $(objtree)/binkernel.spec
 68	+rpmbuild $(RPMOPTS) --define "_builddir $(objtree)" --target \
 69		$(UTS_MACHINE) -bb $(objtree)/binkernel.spec
 70
 71PHONY += deb-pkg
 72deb-pkg:
 73	$(MAKE) clean
 74	$(CONFIG_SHELL) $(srctree)/scripts/package/mkdebian
 75	$(call cmd,src_tar,$(KDEB_SOURCENAME))
 76	origversion=$$(dpkg-parsechangelog -SVersion |sed 's/-[^-]*$$//');\
 77		mv $(KDEB_SOURCENAME).tar.gz ../$(KDEB_SOURCENAME)_$${origversion}.orig.tar.gz
 78	+dpkg-buildpackage -r$(KBUILD_PKG_ROOTCMD) -a$$(cat debian/arch) $(DPKG_FLAGS) -i.git -us -uc
 79
 80PHONY += bindeb-pkg
 81bindeb-pkg:
 82	$(CONFIG_SHELL) $(srctree)/scripts/package/mkdebian
 83	+dpkg-buildpackage -r$(KBUILD_PKG_ROOTCMD) -a$$(cat debian/arch) $(DPKG_FLAGS) -b -nc -uc
 84
 85PHONY += intdeb-pkg
 86intdeb-pkg:
 87	+$(CONFIG_SHELL) $(srctree)/scripts/package/builddeb
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 88
 89# snap-pkg
 90# ---------------------------------------------------------------------------
 91PHONY += snap-pkg
 92snap-pkg:
 93	rm -rf $(objtree)/snap
 94	mkdir $(objtree)/snap
 95	$(MAKE) clean
 96	$(call cmd,src_tar,$(KERNELPATH))
 97	sed "s@KERNELRELEASE@$(KERNELRELEASE)@; \
 98		s@SRCTREE@$(shell realpath $(KERNELPATH).tar.gz)@" \
 99		$(srctree)/scripts/package/snapcraft.template > \
100		$(objtree)/snap/snapcraft.yaml
101	cd $(objtree)/snap && \
102	snapcraft --target-arch=$(UTS_MACHINE)
103
104# tarball targets
105# ---------------------------------------------------------------------------
106tar-pkgs := dir-pkg tar-pkg targz-pkg tarbz2-pkg tarxz-pkg
107PHONY += $(tar-pkgs)
108$(tar-pkgs):
109	$(MAKE) -f $(srctree)/Makefile
110	+$(CONFIG_SHELL) $(srctree)/scripts/package/buildtar $@
111
112# perf-pkg - generate a source tarball with perf source
113# ---------------------------------------------------------------------------
114
115perf-tar=perf-$(KERNELVERSION)
116
117quiet_cmd_perf_tar = TAR
118      cmd_perf_tar = \
119git --git-dir=$(srctree)/.git archive --prefix=$(perf-tar)/         \
120	HEAD^{tree} $$(cd $(srctree);                               \
121		       echo $$(cat tools/perf/MANIFEST)) \
122	-o $(perf-tar).tar;                                         \
123mkdir -p $(perf-tar);                                               \
124git --git-dir=$(srctree)/.git rev-parse HEAD > $(perf-tar)/HEAD;    \
125(cd $(srctree)/tools/perf;                                          \
126util/PERF-VERSION-GEN $(CURDIR)/$(perf-tar)/);              \
127tar rf $(perf-tar).tar $(perf-tar)/HEAD $(perf-tar)/PERF-VERSION-FILE; \
128rm -r $(perf-tar);                                                  \
129$(if $(findstring tar-src,$@),,                                     \
130$(if $(findstring bz2,$@),$(KBZIP2),                                 \
131$(if $(findstring gz,$@),$(KGZIP),                                  \
132$(if $(findstring xz,$@),$(XZ),                                     \
133$(error unknown target $@))))                                       \
134	-f -9 $(perf-tar).tar)
135
136perf-tar-pkgs := perf-tar-src-pkg perf-targz-src-pkg perf-tarbz2-src-pkg perf-tarxz-src-pkg
137PHONY += $(perf-tar-pkgs)
138$(perf-tar-pkgs):
139	$(call cmd,perf_tar)
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
140
141# Help text displayed when executing 'make help'
142# ---------------------------------------------------------------------------
143PHONY += help
144help:
145	@echo '  rpm-pkg             - Build both source and binary RPM kernel packages'
 
146	@echo '  binrpm-pkg          - Build only the binary kernel RPM package'
147	@echo '  deb-pkg             - Build both source and binary deb kernel packages'
 
148	@echo '  bindeb-pkg          - Build only the binary kernel deb package'
149	@echo '  snap-pkg            - Build only the binary kernel snap package'
150	@echo '                        (will connect to external hosts)'
 
151	@echo '  dir-pkg             - Build the kernel as a plain directory structure'
152	@echo '  tar-pkg             - Build the kernel as an uncompressed tarball'
153	@echo '  targz-pkg           - Build the kernel as a gzip compressed tarball'
154	@echo '  tarbz2-pkg          - Build the kernel as a bzip2 compressed tarball'
155	@echo '  tarxz-pkg           - Build the kernel as a xz compressed tarball'
156	@echo '  perf-tar-src-pkg    - Build $(perf-tar).tar source tarball'
157	@echo '  perf-targz-src-pkg  - Build $(perf-tar).tar.gz source tarball'
158	@echo '  perf-tarbz2-src-pkg - Build $(perf-tar).tar.bz2 source tarball'
159	@echo '  perf-tarxz-src-pkg  - Build $(perf-tar).tar.xz source tarball'
 
 
 
 
 
 
 
 
 
 
 
 
 
 
160
161.PHONY: $(PHONY)
v6.13.7
  1# SPDX-License-Identifier: GPL-2.0-only
  2# Makefile for the different targets used to generate full packages of a kernel
  3
  4include $(srctree)/scripts/Kbuild.include
  5include $(srctree)/scripts/Makefile.lib
  6
  7# Git
  8# ---------------------------------------------------------------------------
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
  9
 10filechk_HEAD = git -C $(srctree) rev-parse --verify HEAD 2>/dev/null
 11
 12.tmp_HEAD: check-git FORCE
 13	$(call filechk,HEAD)
 14
 15PHONY += check-git
 16check-git:
 17	@if ! $(srctree)/scripts/check-git; then \
 18		echo >&2 "error: creating source package requires git repository"; \
 19		false; \
 20	fi
 21
 22git-config-tar.gz   = -c tar.tar.gz.command="$(KGZIP)"
 23git-config-tar.bz2  = -c tar.tar.bz2.command="$(KBZIP2)"
 24git-config-tar.lzma = -c tar.tar.lzma.command="$(LZMA)"
 25git-config-tar.xz   = -c tar.tar.xz.command="$(XZ)"
 26git-config-tar.zst  = -c tar.tar.zst.command="$(ZSTD)"
 27
 28quiet_cmd_archive = ARCHIVE $@
 29      cmd_archive = git -C $(srctree) $(git-config-tar$(suffix $@)) archive \
 30                    --output=$$(realpath $@) $(archive-args)
 31
 32suffix-gzip  := .gz
 33suffix-bzip2 := .bz2
 34suffix-lzma  := .lzma
 35suffix-xz    := .xz
 36
 37# Linux source tarball
 38# ---------------------------------------------------------------------------
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 39
 40linux-tarballs := $(addprefix linux, .tar.gz .tar.bz2 .tar.lzma .tar.xz)
 41
 42targets += $(linux-tarballs)
 43$(linux-tarballs): archive-args = --prefix=linux/ $$(cat $<)
 44$(linux-tarballs): .tmp_HEAD FORCE
 45	$(call if_changed,archive)
 46
 47# rpm-pkg srcrpm-pkg binrpm-pkg
 48# ---------------------------------------------------------------------------
 49
 50quiet_cmd_mkspec = GEN     $@
 51      cmd_mkspec = $(srctree)/scripts/package/mkspec $@
 52
 53rpmbuild/SPECS/kernel.spec: FORCE
 54	$(call cmd,mkspec)
 55
 56PHONY += rpm-sources
 57rpm-sources: linux.tar.gz
 58	$(Q)mkdir -p rpmbuild/SOURCES
 59	$(Q)ln -f linux.tar.gz rpmbuild/SOURCES/linux.tar.gz
 60	$(Q)cp $(KCONFIG_CONFIG) rpmbuild/SOURCES/config
 61	$(Q)$(srctree)/scripts/package/gen-diff-patch rpmbuild/SOURCES/diff.patch
 62
 63PHONY += rpm-pkg srcrpm-pkg binrpm-pkg
 64
 65ifneq ($(CC),$(HOSTCC))
 66rpm-no-devel = --without=devel
 67endif
 68
 69rpm-pkg:    private build-type := a
 70srcrpm-pkg: private build-type := s
 71binrpm-pkg: private build-type := b
 72
 73rpm-pkg srcrpm-pkg: rpm-sources
 74rpm-pkg srcrpm-pkg binrpm-pkg: rpmbuild/SPECS/kernel.spec
 75	+$(strip rpmbuild -b$(build-type) rpmbuild/SPECS/kernel.spec \
 76	--define='_topdir $(abspath rpmbuild)' \
 77	$(if $(filter a b, $(build-type)), \
 78		--target $(UTS_MACHINE)-linux --build-in-place --noprep --define='_smp_mflags %{nil}' \
 79		$$(rpm -q rpm >/dev/null 2>&1 || echo --nodeps) \
 80		$(rpm-no-devel)) \
 81	$(RPMOPTS))
 82
 83# deb-pkg srcdeb-pkg bindeb-pkg
 84# ---------------------------------------------------------------------------
 85
 86KDEB_SOURCE_COMPRESS ?= gzip
 87
 88supported-deb-source-compress := gzip bzip2 lzma xz
 89
 90PHONY += linux.tar.unsupported-deb-src-compress
 91linux.tar.unsupported-deb-src-compress:
 92	@echo "error: KDEB_SOURCE_COMPRESS=$(KDEB_SOURCE_COMPRESS) is not supported. The supported values are: $(supported-deb-source-compress)" >&2
 93	@false
 94
 95debian-orig-suffix := \
 96    $(strip $(if $(filter $(supported-deb-source-compress), $(KDEB_SOURCE_COMPRESS)), \
 97    $(suffix-$(KDEB_SOURCE_COMPRESS)),.unsupported-deb-src-compress))
 98
 99quiet_cmd_debianize = GEN     $@
100      cmd_debianize = $(srctree)/scripts/package/mkdebian $(mkdebian-opts)
101
102debian: FORCE
103	$(call cmd,debianize)
104
105PHONY += debian-orig
106debian-orig: private source = $(shell dpkg-parsechangelog -S Source)
107debian-orig: private version = $(shell dpkg-parsechangelog -S Version | sed 's/-[^-]*$$//')
108debian-orig: private orig-name = $(source)_$(version).orig.tar$(debian-orig-suffix)
109debian-orig: mkdebian-opts = --need-source
110debian-orig: linux.tar$(debian-orig-suffix) debian
111	$(Q)if [ "$$(df  --output=target .. 2>/dev/null)" = "$$(df --output=target $< 2>/dev/null)" ]; then \
112		ln -f $< ../$(orig-name); \
113	else \
114		cp $< ../$(orig-name); \
115	fi
116
117PHONY += deb-pkg srcdeb-pkg bindeb-pkg
118
119deb-pkg:    private build-type := source,binary
120srcdeb-pkg: private build-type := source
121bindeb-pkg: private build-type := binary
122
123deb-pkg srcdeb-pkg: debian-orig
124bindeb-pkg: debian
125deb-pkg srcdeb-pkg bindeb-pkg:
126	+$(strip dpkg-buildpackage \
127	--build=$(build-type) --no-pre-clean --unsigned-changes \
128	$(if $(findstring source, $(build-type)), \
129		--unsigned-source --compression=$(KDEB_SOURCE_COMPRESS)) \
130	$(if $(findstring binary, $(build-type)), \
131		-R'$(MAKE) -f debian/rules' -j1 -a$$(cat debian/arch), \
132		--no-check-builddeps) \
133	$(DPKG_FLAGS))
134
135# snap-pkg
136# ---------------------------------------------------------------------------
137PHONY += snap-pkg
138snap-pkg:
139	rm -rf $(objtree)/snap
140	mkdir $(objtree)/snap
141	$(MAKE) clean
 
142	sed "s@KERNELRELEASE@$(KERNELRELEASE)@; \
143		s@SRCTREE@$(realpath $(srctree))@" \
144		$(srctree)/scripts/package/snapcraft.template > \
145		$(objtree)/snap/snapcraft.yaml
146	cd $(objtree)/snap && \
147	snapcraft --target-arch=$(UTS_MACHINE)
148
149# pacman-pkg
150# ---------------------------------------------------------------------------
151
152PHONY += pacman-pkg
153pacman-pkg:
154	@ln -srf $(srctree)/scripts/package/PKGBUILD $(objtree)/PKGBUILD
155	+BUILDDIR="$(realpath $(objtree))/pacman" \
156		CARCH="$(UTS_MACHINE)" \
157		KBUILD_MAKEFLAGS="$(MAKEFLAGS)" \
158		KBUILD_REVISION="$(shell $(srctree)/scripts/build-version)" \
159		makepkg $(MAKEPKGOPTS)
160
161# dir-pkg tar*-pkg - tarball targets
162# ---------------------------------------------------------------------------
163
164tar-install: FORCE
165	$(Q)$(MAKE) -f $(srctree)/Makefile
166	+$(Q)$(srctree)/scripts/package/buildtar $@
167
168compress-tar.gz  = -I "$(KGZIP)"
169compress-tar.bz2 = -I "$(KBZIP2)"
170compress-tar.xz  = -I "$(XZ)"
171compress-tar.zst = -I "$(ZSTD)"
172
173quiet_cmd_tar = TAR     $@
174      cmd_tar = cd $<; tar cf ../$@ $(compress-tar$(suffix $@)) --owner=root --group=root --sort=name *
175
176dir-tarballs := $(addprefix linux-$(KERNELRELEASE)-$(ARCH), .tar .tar.gz .tar.bz2 .tar.xz .tar.zst)
177
178$(dir-tarballs): tar-install
179	$(call cmd,tar)
180
181PHONY += dir-pkg
182dir-pkg: tar-install
183	@echo "Kernel tree successfully created in $<"
184
185PHONY += tar-pkg
186tar-pkg: linux-$(KERNELRELEASE)-$(ARCH).tar
187	@:
188
189tar%-pkg: linux-$(KERNELRELEASE)-$(ARCH).tar.% FORCE
190	@:
191
192# perf-tar*-src-pkg - generate a source tarball with perf source
193# ---------------------------------------------------------------------------
194
195.tmp_perf:
196	$(Q)mkdir .tmp_perf
197
198.tmp_perf/HEAD: .tmp_HEAD | .tmp_perf
199	$(call cmd,copy)
200
201quiet_cmd_perf_version_file = GEN     $@
202      cmd_perf_version_file = cd $(srctree)/tools/perf; util/PERF-VERSION-GEN $(dir $(abspath $@))
203
204# PERF-VERSION-FILE and .tmp_HEAD are independent, but this avoids updating the
205# timestamp of PERF-VERSION-FILE.
206# The best is to fix tools/perf/util/PERF-VERSION-GEN.
207.tmp_perf/PERF-VERSION-FILE: .tmp_HEAD $(srctree)/tools/perf/util/PERF-VERSION-GEN | .tmp_perf
208	$(call cmd,perf_version_file)
209
210perf-archive-args = --add-file=$$(realpath $(word 2, $^)) \
211	--add-file=$$(realpath $(word 3, $^)) \
212	$$(cat $(word 2, $^))^{tree} $$(cat $<)
213
214
215perf-tarballs := $(addprefix perf-$(KERNELVERSION), .tar .tar.gz .tar.bz2 .tar.xz .tar.zst)
216
217targets += $(perf-tarballs)
218$(perf-tarballs): archive-args = --prefix=perf-$(KERNELVERSION)/ $(perf-archive-args)
219$(perf-tarballs): tools/perf/MANIFEST .tmp_perf/HEAD .tmp_perf/PERF-VERSION-FILE FORCE
220	$(call if_changed,archive)
221
222PHONY += perf-tar-src-pkg
223perf-tar-src-pkg: perf-$(KERNELVERSION).tar
224	@:
225
226perf-tar%-src-pkg: perf-$(KERNELVERSION).tar.% FORCE
227	@:
228
229# Help text displayed when executing 'make help'
230# ---------------------------------------------------------------------------
231PHONY += help
232help:
233	@echo '  rpm-pkg             - Build both source and binary RPM kernel packages'
234	@echo '  srcrpm-pkg          - Build only the source kernel RPM package'
235	@echo '  binrpm-pkg          - Build only the binary kernel RPM package'
236	@echo '  deb-pkg             - Build both source and binary deb kernel packages'
237	@echo '  srcdeb-pkg          - Build only the source kernel deb package'
238	@echo '  bindeb-pkg          - Build only the binary kernel deb package'
239	@echo '  snap-pkg            - Build only the binary kernel snap package'
240	@echo '                        (will connect to external hosts)'
241	@echo '  pacman-pkg          - Build only the binary kernel pacman package'
242	@echo '  dir-pkg             - Build the kernel as a plain directory structure'
243	@echo '  tar-pkg             - Build the kernel as an uncompressed tarball'
244	@echo '  targz-pkg           - Build the kernel as a gzip compressed tarball'
245	@echo '  tarbz2-pkg          - Build the kernel as a bzip2 compressed tarball'
246	@echo '  tarxz-pkg           - Build the kernel as a xz compressed tarball'
247	@echo '  tarzst-pkg          - Build the kernel as a zstd compressed tarball'
248	@echo '  perf-tar-src-pkg    - Build the perf source tarball with no compression'
249	@echo '  perf-targz-src-pkg  - Build the perf source tarball with gzip compression'
250	@echo '  perf-tarbz2-src-pkg - Build the perf source tarball with bz2 compression'
251	@echo '  perf-tarxz-src-pkg  - Build the perf source tarball with xz compression'
252	@echo '  perf-tarzst-src-pkg - Build the perf source tarball with zst compression'
253
254PHONY += FORCE
255FORCE:
256
257# Read all saved command lines and dependencies for the $(targets) we
258# may be building above, using $(if_changed{,_dep}). As an
259# optimization, we don't need to read them if the target does not
260# exist, we will rebuild anyway in that case.
261
262existing-targets := $(wildcard $(sort $(targets)))
263
264-include $(foreach f,$(existing-targets),$(dir $(f)).$(notdir $(f)).cmd)
265
266.PHONY: $(PHONY)